unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.StdCtrls,

  //T.b.v. Telefoon
  FMX.Platform, FMX.PhoneDialer,

  //T.B.V. BringAppToFront
  FMX.Platform.Android,
  Androidapi.JNI.GraphicsContentViewText,
  Androidapi.Helpers,

  //T.b.v. Toestemmingen
  System.Permissions,
  Androidapi.Jni.Os;
  //Androidapi.Helpers;


  //Math,
  //System.IOUtils,

  //Androidapi.JNI.Provider,
  //Androidapi.JNI.GraphicsContentViewText;


  //T.B.V. Threads (Code die op de achtergrond draait)
  //System.Threading;
  //System.SyncObjs;

  //T.B.V. BringAppToFront
  //FMX.Platform.Android;

  //Threads
  //System.Threading;
  //System.SyncObjs;




type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Toestemming_1();
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BringAppToFront;
  private
    { Private declarations }
    PhoneDialerService: IFMXPhoneDialerService;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}


// Probleem, dit werkt maar 1x


//------------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
begin
 TPlatformServices.Current.SupportsPlatformService(IFMXPhoneDialerService,
 IInterface(PhoneDialerService));

 Toestemming_1();
end;

//------------------------------------------------------------------------------

//Toestemming: Telefoon
procedure TForm1.Toestemming_1();
begin

 //Telefoon
 PermissionsService.RequestPermissions([JStringToString(TJManifest_permission.JavaClass.CALL_PHONE)],
  procedure(const APermissions: TArray<string>; const AGrantResults: TArray<TPermissionStatus>)
    begin
     if (Length(AGrantResults) = 1) and (AGrantResults[0] = TPermissionStatus.Granted) then
       begin
        //Er is Toestemming voor het gebruik van de Telefoon
        TPlatformServices.Current.SupportsPlatformService(IFMXPhoneDialerService,
        IInterface(PhoneDialerService));
        //Toestemming_4(); //De Volgende Toestemming Vragen
        //App_Start();
       end
     else
       begin
        //Er is Geen Toestemming voor het gebruik van de Telefoon

        MessageDlg('Deze App kan niet werken Zonder toegang tot de Telefoon.' + #13#10 +
        'Als deze keuze niet meer verschijnt:' + #13#10 +
        '-Instellingen' + #13#10 +
        '-Apps' + #13#10 +
        '-Zoek deze App' + #13#10 +
        '-Rechten/Machtigingen' + #13#10 +
        '-Telefoon Aanzetten' + #13#10 +
        'Of Verwijder de App en Installeer deze opnieuw !' + #13#10 +
        #13#10 +
        'App Afsluiten ?', TMsgDlgType.mtConfirmation,
        [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0,
        procedure(const AResult: TModalResult)
         begin
          if AResult = mrYes then
           begin
            Application.Terminate; //App Afsluiten
            Exit;
           end
          else
           Toestemming_1(); //Nogmaals Toestemming Vragen
         end);

       end;
    end);

end;

//------------------------------------------------------------------------------


procedure TForm1.Button1Click(Sender: TObject);
begin
 Timer1.Enabled := True;
 PhoneDialerService.Call('06-12345678');
end;

//------------------------------------------------------------------------------

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 BringAppToFront;
 Timer1.Enabled := False;
end;

//------------------------------------------------------------------------------

procedure TForm1.BringAppToFront;
var
 Intent: JIntent;
begin
 Intent := TJIntent.Create;
 Intent.setClassName(MainActivity.getPackageName, MainActivity.getClass.getName);
 Intent.setAction(TJIntent.JavaClass.ACTION_MAIN);
 Intent.addCategory(TJIntent.JavaClass.CATEGORY_LAUNCHER);
 Intent.addFlags(TJIntent.JavaClass.FLAG_ACTIVITY_NEW_TASK);
 TAndroidHelper.Activity.getBaseContext.startActivity(Intent);

 Sleep(10000); //!0 Sec.
end;

//------------------------------------------------------------------------------





end.
